<?php

declare(strict_types=1);

namespace Kylin\Pay\Shortcut\Wechat;

use Kylin\Pay\Artful\Contract\ShortcutInterface;
use Kylin\Pay\Artful\Exception\InvalidParamsException;
use Kylin\Pay\Artful\Plugin\AddPayloadBodyPlugin;
use Kylin\Pay\Artful\Plugin\ParserPlugin;
use Kylin\Pay\Artful\Plugin\StartPlugin;
use Kylin\Pay\Exception\Exception;
use Kylin\Pay\Plugin\Wechat\AddRadarPlugin;
use Kylin\Pay\Plugin\Wechat\ResponsePlugin;
use Kylin\Pay\Plugin\Wechat\V3\AddPayloadSignaturePlugin;
use Kylin\Pay\Plugin\Wechat\V3\Marketing\MchTransfer\CancelPlugin;
use Kylin\Pay\Plugin\Wechat\V3\VerifySignaturePlugin;
use Kylin\Pay\Supports\Str;

class CancelShortcut implements ShortcutInterface
{
    /**
     * @throws InvalidParamsException
     */
    public function getPlugins(array $params): array
    {
        $method = Str::camel($params['_action'] ?? 'default').'Plugins';

        if (method_exists($this, $method)) {
            return $this->{$method}();
        }

        throw new InvalidParamsException(Exception::PARAMS_SHORTCUT_ACTION_INVALID, "您所提供的 action 方法 [{$method}] 不支持，请参考文档或源码确认");
    }

    protected function defaultPlugins(): array
    {
        return $this->mchTransferPlugins();
    }

    protected function mchTransferPlugins(): array
    {
        return [
            StartPlugin::class,
            CancelPlugin::class,
            AddPayloadBodyPlugin::class,
            AddPayloadSignaturePlugin::class,
            AddRadarPlugin::class,
            VerifySignaturePlugin::class,
            ResponsePlugin::class,
            ParserPlugin::class,
        ];
    }
}
